## cryptsetup 1.7.3

=== debian/changelog ===
cryptsetup (2:1.7.3-3) unstable; urgency=medium

  [ Jonas Meurer ]
  * debian/scripts/decrypt_ssl: fix script to actually output the decrypted
    key. Apparently this script has been broken since June 2008. Doesn't seem
    like anybody is using it. Thanks to g1 for spotting and reporting the
    error. (Closes: #844050)
  * debian/initramfs/cryptroot-script:
    + limit the sleep after max passphrase attempts to devices for the rootfs.
      This mitigates the negative impact in case of broken keyscripts etc.
    + add $crypttarget to each message to provide more context.
  * debian/initramfs/cryptroot-hook: fix sanity check for key files on root
    fs in get_device_opts(): detect if processed device is a root (parent)
    device even for LVM setups. (closes: #842951)
  * debian/README.initramfs: minor fix to the decrypt_derived keyscript
    section: now that systemd is standard, 'cryptdisks_start' should be used
    instead of '/etc/init.d/cryptdisks start'.
  * debian/manpages/crypttab.xml: add a warning to the 'keyscript' option
    that systemd doesn't support the option (yet) and mention the possible
    workaround to process the devices in question in the initramfs.

  [ Guilhem Moulin ]
  * add debian/gbp.conf to set the upstream tag to "v%(version%.%_)s".  As
    this enables git-buildpackage >= 0.8.7 to automatically generate
    orig.tar.gz, step nr. 5 is now removed from debian/README.source.
  * debian/compat: bump debhelper compatibility version to 9.
  * debian/initramfs/cryptroot-hook:
    + fix tab damage for consistency with the rest of the code
    + better warning for deprecated settings
    + fix sanity check for key files in get_device_opts(): print a warning if
      the key file isn't on the root FS, or if the root device is not
      encrypted, even for LVM setups.
    + fix sanity check for key files in get_device_opts(): print a warning if
      the processed device is a resume device, even for LVM setups.
    + fix runtime error in get_lvm_deps() if the first argument is either
      missing or the empty string.
    + reset IFS after processing $rootopts in get_device_opts(); the missing
      linefeed in $IFS caused LVM logical volumes spaning over multiple PVs
      not to have their parent devices detected correctly.

 -- Jonas Meurer <mejo@debian.org>  Fri, 09 Dec 2016 01:18:17 +0100

cryptsetup (2:1.7.3-2) unstable; urgency=medium

  [ Guilhem Moulin ]
  * debian/README.Debian: update authorized_keys(5) path, incorrect since
    2:1.7.2-1, for remote unlocking at initramfs stage using the dropbear SSH
    server.

  [ Jonas Meurer ]
  * debian/initramfs/cryptroot-script: sleep after max passphrase attempts.
    This mitigates local brute-force attacks and addresses CVE-2016-4484.
    Thanks to Ismael Ripoll and Hector Marco for discovery and report.
    - decrease $count by one in tries loop if unlocking was successful.
    - warn and sleep for 60 seconds if the maximum allowed attempts of
      unlocking (configured with crypttab option tries, default=3) are
      reached.

 -- Jonas Meurer <mejo@debian.org>  Mon, 07 Nov 2016 11:34:41 +0100

cryptsetup (2:1.7.3-1) unstable; urgency=medium

  * New upstream release 1.7.3.
  * debian/rules: run dh_strip_nondeterminism(1p) in binary-arch rules to
    make the package build more reproducible. Introduces a new Build-Depends
    on dh-strip-nondeterminism. Thanks to Reiner Herrmann for bugreport and
    patch. (Closes: #842581)

 -- Jonas Meurer <mejo@debian.org>  Mon, 31 Oct 2016 22:00:52 +0100

cryptsetup (2:1.7.2-5) unstable; urgency=high

  [ Guilhem Moulin ]
  * debian/upstream/signing-key.asc: add upstream's armored OpenPGP key,
    fingerprint 2A29 1824 3FDE 4664 8D06  86F9 D9B0 577B D93E 98FC.
  * debian/watch: add "pgpsigurlmangle" option so uscan(1) can automatically
    verify cryptographic signatures on release tarballs.

  [ Jonas Meurer ]
  * debian/initramfs/cryptroot-hook: only source crypt-hook from
    /etc/cryptsetup-initramfs/ when present. (Closes: #841503)

 -- Jonas Meurer <mejo@debian.org>  Fri, 21 Oct 2016 18:10:56 +0200

cryptsetup (2:1.7.2-4) unstable; urgency=high

  [ Guilhem Moulin ]
  * debian/initramfs/cryptroot-hook:
    + Fix warning printed for lvm devices backed by multiple dm-crypt nodes.
      Regression introduced in 2:1.7.2-1.  Thanks Zoltan Hidvegi, for the
      patch. (Closes: #840480)
    + Don't escape all slash characters "/" in device paths of the form
      /dev/by-label/..., only the label itself.  Regression introduced in
      2:1.7.2-2 as a fix for #839888.

 -- Jonas Meurer <mejo@debian.org>  Thu, 13 Oct 2016 23:11:45 +0200

cryptsetup (2:1.7.2-3) unstable; urgency=medium

  [ Guilhem Moulin ]
  * debian/initramfs/cryptroot-conf: don't set CRYPTSETUP and KEYFILE_PATTERN,
    so the (deprecated) values set in /etc/initramfs-tools aren't overridden
    to the empty string by default.  Regression introduced in 2:1.7.2-1.
    (Closes: #839994.)
  * debian/README.initramfs: fixed minor typo.

 -- Jonas Meurer <mejo@debian.org>  Sat, 08 Oct 2016 00:01:25 +0200

cryptsetup (2:1.7.2-2) unstable; urgency=medium

  * debian/cryptdisks.functions: fix a nasty typo in do_start that rendered
    systems with sysVinit unbootable. Thanks to Marc Haber for bugreport and
    patch (Closes: #839888)

 -- Jonas Meurer <mejo@debian.org>  Thu, 06 Oct 2016 10:47:05 +0200

cryptsetup (2:1.7.2-1) unstable; urgency=medium

  [ Jonas Meurer ]
  * new upstream release 1.7.2. Highlights include:
    - code now uses kernel crypto API backend according to new changes
      introduced in mainline kernel. (in 1.7.1)
    - cryptsetup now allows special "-" (standard input) keyfile handling
      even for TCRYPT (TrueCrypt and VeraCrypt compatible) devices. (in 1.7.1)
    - Support activation options for error handling modes in Linux kernel
      dm-verity module. (in 1.7.2)
  * debian/cryptdisks.functions: use '--key-file=-' again with the tcrypt


=== debian/control ===
Source: cryptsetup
Section: admin
Priority: optional
Maintainer: Debian Cryptsetup Team <pkg-cryptsetup-devel@lists.alioth.debian.org>
Uploaders: Jonas Meurer <mejo@debian.org>,
 Guilhem Moulin <guilhem@guilhem.org>
Build-Depends: libgcrypt20-dev (>= 1.6.1), libdevmapper-dev (>= 2:1.02.24-4), libpopt-dev, uuid-dev, libselinux1-dev, libsepol1-dev, libtool (>= 2.2), autoconf, automake (>= 1:1.12), pkg-config, autopoint, gettext, debhelper (>= 9.20120410~), xsltproc, docbook-xml, docbook-xsl (>= 1.74.3+dfsg), dpkg-dev (>= 1.15.1), po-debconf, dh-strip-nondeterminism
Standards-Version: 3.9.8
Homepage: https://gitlab.com/cryptsetup/cryptsetup
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-cryptsetup/cryptsetup.git
Vcs-Git: https://anonscm.debian.org/git/pkg-cryptsetup/cryptsetup.git

Package: cryptsetup
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, dmsetup, cryptsetup-bin (>= 2:1.6.0)
Recommends: kbd, console-setup, initramfs-tools (>= 0.91) | linux-initramfs-tool, busybox | busybox-static
Suggests: dosfstools, liblocale-gettext-perl, keyutils
Provides: cryptsetup-luks
Conflicts: cryptsetup-luks
Replaces: cryptsetup-luks, hashalot (<< 0.3-2)
Breaks: hashalot (<< 0.3-2)
Description: disk encryption support - startup scripts
 Cryptsetup provides an interface for configuring encryption on block
 devices (such as /home or swap partitions), using the Linux kernel
 device mapper target dm-crypt. It features integrated Linux Unified Key
 Setup (LUKS) support.
 .
 Cryptsetup is backwards compatible with the on-disk format of cryptoloop,
 but also supports more secure formats. This package includes support for
 automatically configuring encrypted devices at boot time via the config
 file /etc/crypttab. Additional features are cryptoroot support through
 initramfs-tools and several supported ways to read a passphrase or key.

Package: cryptsetup-bin
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: cryptsetup (<< 2:1.4.3-1~)
Replaces: cryptsetup (<< 2:1.4.3-1~)
Description: disk encryption support - command line tools
 Cryptsetup provides an interface for configuring encryption on block
 devices (such as /home or swap partitions), using the Linux kernel
 device mapper target dm-crypt. It features integrated Linux Unified Key
 Setup (LUKS) support.
 .
 This package provides cryptsetup, cryptsetup-reencrypt and luksformat.

Package: libcryptsetup4
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libgpg-error0 (>= 1.10-0.1), libgcrypt20 (>= 1.6.1)
Description: disk encryption support - shared library
 Cryptsetup provides an interface for configuring encryption on block
 devices (such as /home or swap partitions), using the Linux kernel
 device mapper target dm-crypt. It features integrated Linux Unified Key
 Setup (LUKS) support.
 .
 This package provides the libcryptsetup shared library.

Package: libcryptsetup-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, libcryptsetup4 (= ${binary:Version})
Description: disk encryption support - development files
 Cryptsetup provides an interface for configuring encryption on block
 devices (such as /home or swap partitions), using the Linux kernel
 device mapper target dm-crypt. It features integrated Linux Unified Key
 Setup (LUKS) support.
 .
 This package provides the libcryptsetup development files.

Package: cryptsetup-udeb
Section: debian-installer
Package-Type: udeb
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, dmsetup-udeb
Description: disk encryption support - commandline tools (udeb)
 Cryptsetup provides an interface for configuring encryption on block
 devices (such as /home or swap partitions), using the Linux kernel
 device mapper target dm-crypt. It features integrated Linux Unified Key
 Setup (LUKS) support.
 .
 This udeb package provides cryptsetup for the Debian Installer.

Package: libcryptsetup4-udeb
Section: debian-installer
Package-Type: udeb
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: disk encryption support - shared library (udeb)
 Cryptsetup provides an interface for configuring encryption on block
 devices (such as /home or swap partitions), using the Linux kernel
 device mapper target dm-crypt. It features integrated Linux Unified Key
 Setup (LUKS) support.
 .
 This udeb package provides libcryptsetup for the Debian Installer.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Turn on verbose mode.
export V=1

# Uncomment this to turn on debhelper verbose mode.
#export DH_VERBOSE=1

DEB_VERSION := $(strip $(shell LC_ALL=C dpkg-parsechangelog --show-field Version))
DEB_DATE    := $(strip $(shell LC_ALL=C dpkg-parsechangelog --show-field Date | \
                               LC_ALL=C date -u --file=- +%F                    ))

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif
ifeq ($(origin CC),default)
  CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

# Export dpkg build flags
DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie
DEB_CFLAGS_MAINT_APPEND = -Wall
DPKG_EXPORT_BUILDFLAGS  = 1
-include /usr/share/dpkg/buildflags.mk

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	find -xtype f ! -name manifest >manifest
	autoreconf --force --install
	./configure $(confflags)  \
		--prefix=/usr \
		--libdir=/lib \
		--sbindir=/sbin \
		--mandir=/usr/share/man \
		--enable-shared \
		--enable-cryptsetup-reencrypt
	find -xtype f >manifest.new
	diff manifest manifest.new | grep '>' | cut -b3- >config.mess
	touch $@

build-stamp: configure-stamp
	touch $@


build-indep: build-stamp
	dh_testdir
	# generate manpages
	sed 's/VERSION/$(DEB_VERSION)/;s/DATE/$(DEB_DATE)/' \
		debian/doc/variables.xml.in >debian/doc/variables.xml
	xsltproc --nonet --xinclude -o debian/doc/ \
		/usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl \
		debian/doc/manpages.xml
	pod2man --section=8 --center="Administrative commands" \
		--release="$(DEB_VERSION)" debian/scripts/luksformat \
		debian/luksformat.8
	# generate gettext po files (for luksformat)
	$(MAKE) -C debian/scripts/po all luksformat.pot

build-arch: build-stamp
	dh_testdir
	# build upstream cryptsetup
	$(MAKE)
	# build askpass and passdev keyscripts
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -pedantic -std=c99 debian/askpass.c -o debian/askpass
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -pedantic -std=c99 debian/passdev.c -o debian/scripts/passdev

build: build-indep build-arch

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_clean
	dh_installdirs
	mkdir -p $(CURDIR)/debian/cryptsetup-udeb
	mkdir -p $(CURDIR)/debian/libcryptsetup4-udeb
	$(MAKE) DESTDIR=$(CURDIR)/debian/cryptsetup-bin install

	# Copy library files to library packages
	mkdir -p $(CURDIR)/debian/libcryptsetup4/lib/$(DEB_HOST_MULTIARCH)/
	mkdir -p $(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	#mkdir -p $(CURDIR)/debian/libcryptsetup4/usr/lib/$(DEB_HOST_MULTIARCH)/

	cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.so.* \
		$(CURDIR)/debian/libcryptsetup4/lib/$(DEB_HOST_MULTIARCH)/
	#cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.la \
	#	$(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
	#cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.a \
	#	$(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
	cp -a $(CURDIR)/debian/cryptsetup-bin/lib/pkgconfig/libcryptsetup.pc \
		$(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
	cp -a $(CURDIR)/debian/cryptsetup-bin/usr/include/libcryptsetup.h \
		$(CURDIR)/debian/libcryptsetup-dev/usr/include/
	#cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.so \
	#	$(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
	dh_link -plibcryptsetup-dev lib/$(DEB_HOST_MULTIARCH)/$$(basename $$(readlink debian/libcryptsetup4/lib/$(DEB_HOST_MULTIARCH)/libcryptsetup.so.4)) usr/lib/$(DEB_HOST_MULTIARCH)/libcryptsetup.so

	# Remove libraries from cryptsetup package, they're shiped in seperate library packages
	rm -rf $(CURDIR)/debian/cryptsetup-bin/lib
	rm -rf $(CURDIR)/debian/cryptsetup-bin/usr/include

	install -m 0644 debian/cryptdisks.functions $(CURDIR)/debian/cryptsetup/lib/cryptsetup/
	install -m 0755 debian/checks/* $(CURDIR)/debian/cryptsetup/lib/cryptsetup/checks/
	install -m 0755 debian/scripts/luksformat $(CURDIR)/debian/cryptsetup-bin/usr/sbin/
	install -m 0755 debian/scripts/cryptdisks_start $(CURDIR)/debian/cryptsetup/sbin/
	install -m 0755 debian/scripts/cryptdisks_stop $(CURDIR)/debian/cryptsetup/sbin/
	install -m 0755 debian/scripts/decrypt_* $(CURDIR)/debian/cryptsetup/lib/cryptsetup/scripts/
	install -m 0755 debian/scripts/passdev $(CURDIR)/debian/cryptsetup/lib/cryptsetup/scripts/
	install -m 0755 debian/askpass $(CURDIR)/debian/cryptsetup/lib/cryptsetup/
	install -m 0755 debian/initramfs/cryptgnupg-hook \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/hooks/cryptgnupg
	install -m 0755 debian/initramfs/cryptkeyctl-hook \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/hooks/cryptkeyctl
	install -m 0755 debian/initramfs/cryptopenct-hook \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/hooks/cryptopenct
	install -m 0755 debian/initramfs/cryptopensc-hook \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/hooks/cryptopensc
	install -m 0755 debian/initramfs/cryptopensc-script-local-bottom \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/scripts/local-bottom/cryptopensc
	install -m 0755 debian/initramfs/cryptopensc-script-local-top \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/scripts/local-top/cryptopensc
	install -m 0755 debian/initramfs/cryptpassdev-hook \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/hooks/cryptpassdev
	install -m 0644 debian/initramfs/cryptroot-initramfs.conf \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/conf-hooks.d/cryptsetup
	install -m 0644 debian/initramfs/cryptroot-conf \
		$(CURDIR)/debian/cryptsetup/etc/cryptsetup-initramfs/conf-hook
	install -m 0755 debian/initramfs/cryptroot-hook \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/hooks/cryptroot
	install -m 0755 debian/initramfs/cryptroot-unlock \
		$(CURDIR)/debian/cryptsetup/usr/share/cryptsetup/initramfs/bin/cryptroot-unlock
	install -m 0755 debian/initramfs/cryptroot-unlock-hook \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/hooks/cryptroot-unlock
	install -m 0755 debian/initramfs/cryptroot-script \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/scripts/local-top/cryptroot
	install -m 0755 debian/initramfs/cryptroot-script-block \
		$(CURDIR)/debian/cryptsetup/usr/share/initramfs-tools/scripts/local-block/cryptroot
	install -m 0644 debian/cryptdisks.bash_completion \
		$(CURDIR)/debian/cryptsetup/usr/share/bash-completion/completions/cryptdisks
	install -m 0755 debian/cryptsetup.bug-script \
		$(CURDIR)/debian/cryptsetup/usr/share/bug/cryptsetup
ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes),yes)
	mkdir -p $(CURDIR)/debian/cryptsetup/usr/share/apport/package-hooks
	install -m 0644 debian/cryptsetup.apport \
		$(CURDIR)/debian/cryptsetup/usr/share/apport/package-hooks/cryptsetup.py
endif

	$(MAKE) -C debian/scripts/po DESTDIR=$(CURDIR)/debian/cryptsetup-bin install
	touch $@

binary-indep: build install
# We have nothing to do by default.

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdebconf -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a debian/scripts/gen-ssl-key
	dh_installinit -a --no-start --name=cryptdisks-early --update-rcd-params="start 26 S . start 59 0 6 ."
	dh_installinit -a --no-start --name=cryptdisks-udev

=== debian/watch ===
version=4
options="decompress,pgpsigurlmangle=s/\.(?:gz|xz)$/.sign/" \
	https://www.kernel.org/pub/linux/utils/cryptsetup/v(\d[\d\.]*)/ \
	cryptsetup-(\d[\d\.]*)\.tar\.(?:gz|xz)

## cryptsetup 2.0.2

=== misc/luks2_keyslot_example/Makefile ===
TARGET=keyslot_test
CFLAGS=-O0 -g -Wall -D_GNU_SOURCE -I ../../lib/
LDLIBS=-ljson-c -luuid -lgcrypt -ldevmapper -lpthread -lssh
CC=gcc

TARGET2=keyslot_test_remote_pass
TARGET4=keyslot_add_by_key

SOURCES=keyslot_test.c
OBJECTS=$(SOURCES:.c=.o)
SOURCES2=keyslot_test_remote_pass.c
OBJECTS2=$(SOURCES2:.c=.o)
SOURCES4=keyslot_add_by_key.c
OBJECTS4=$(SOURCES4:.c=.o)

all: $(TARGET) $(TARGET2) $(TARGET4)

$(TARGET): $(OBJECTS) ../../.libs/libcryptsetup.a
	$(CC) -o $@ $^ $(LDLIBS)

$(TARGET2): $(OBJECTS2) ../../.libs/libcryptsetup.a
	$(CC) -o $@ $^ $(LDLIBS)

$(TARGET4): $(OBJECTS4) ../../.libs/libcryptsetup.a
	$(CC) -o $@ $^ $(LDLIBS)

clean:
	rm -f *.o *~ core $(TARGET) $(TARGET2) $(TARGET4)

.PHONY: clean

=== debian/changelog ===
cryptsetup (2:2.0.2-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.
    - bugfix upstream release, which solves problems with luks2 format
      disks not unlocking.  LP: #1755322.
  * Remaining changes:
    - debian/control:
      + Depend on plymouth.
      + Invert the "busybox | busybox-static" Recommends, as the latter
        is the one we ship in main as part of the ubuntu-standard task.
      + Drop explicit libgcrypt20 dependency from libcryptsetup4.
    - Drop _BSD_SOURCE in favor of _DEFAULT_SOURCE
    - Drop c99 std, as the default is now higher than that
    - Drop upstart system jobs.
    - Add maintscript to drop removed upstart system jobs.
      - debian has its own now, but we have different version numbers.
        this delta can be dropped after 18.04 release.
    - Drop the CRYPTSETUP variable warning from the initramfs hook, as
      overlayroot package ships a dropin in conf-hooks.d triggering false
      warnings.
  * Dropped changes:
    - debian/cryptdisks{,-udev}.maintscript: drop, there is no package named
      'cryptdisks' or 'cryptdisks-udev'.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 06 Apr 2018 10:23:53 -0700

cryptsetup (2:2.0.2-1) unstable; urgency=low

  * New upstream release 2.0.2
  * debian/initramfs/cryptroot-hook: copy libgcc_s.so.1 to the initrd, as
    libargon2 (used by LUKS2 devices) uses pthread_cancel.  (Closes: #890798.)
  * debian/initramfs/cryptroot-script: create locking directory at initramfs
    stage, before running the cryptsetup binary, which would create it
    automatically but also spew a warning.
  * debian/patches/Fix-loopaesOpen-for-keyfile-on-standard-input.patch:
    removed as it was cherry-picked from upstream and included in 2.0.2.
  * debian/libcryptsetup12.symbols: update with new crypt_token_is_assigned()
    API function.

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 17 Mar 2018 18:03:03 +0100

cryptsetup (2:2.0.1-1) unstable; urgency=low

  * New upstream release 2.0.1:
    - Use /run/cryptsetup as default for cryptsetup locking dir.
    - Add missing symbols for new functions to debian/libcryptsetup12.symbols.
  * debian/copyright: update copyright years.
  * debian/patches: backport upstream's 8728ba08 to fix opening of loop-AES
    devices using --key-file=-.  (Closes: #888162.)
  * debian/rules: replace `autoreconf -f -i` with `dh_autoreconf` and add
    `dh_autoreconf_clean` to the "clean:" target.  This bumps the minimum
    debhelper version to 9.20160403~ in Build-Depends. (Closes: #888742.)

 -- Guilhem Moulin <guilhem@debian.org>  Sun, 11 Feb 2018 00:02:05 +0100

cryptsetup (2:2.0.1-0ubuntu2) bionic; urgency=medium

  * Drop the CRYPTSETUP variable warning from the initramfs hook, as
    overlayroot package ships a dropin in conf-hooks.d triggering false
    warnings.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 22 Feb 2018 14:49:16 +0000

cryptsetup (2:2.0.1-0ubuntu1) bionic; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - debian/control:
      + Depend on plymouth.
      + Invert the "busybox | busybox-static" Recommends, as the latter
        is the one we ship in main as part of the ubuntu-standard task.
      + Drop explicit libgcrypt20 dependency from libcryptsetup4.
    - Drop _BSD_SOURCE in favor of _DEFAULT_SOURCE
    - Drop c99 std, as the default is now higher than that
    - Drop upstart system jobs.
    - Add maintscript to drop removed upstart system jobs.
      - debian has its own now, but we have different version numbers
  * New upstream release
  * Cherry-pick Guilhem Moulin's changes below from Debian git

  [ Guilhem Moulin ]
   * New upstream release 2.0.1:
     - Use /run/cryptsetup as default for cryptsetup locking dir.
     - Add missing symbols for new functions to debian/libcryptsetup12.symbols.
  * debian/copyright: update copyright years.
  * debian/patches: backport upstream's 8728ba08 to fix opening of loop-AES
    devices using --key-file=-.  (Closes: #888162.)

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 29 Jan 2018 13:48:55 +0100

cryptsetup (2:2.0.0-1) unstable; urgency=low

  [ Guilhem Moulin ]
  * cryptsetup-bin: Install /usr/lib/tmpfiles.d/cryptsetup.conf to create the
    LUKS2 locking directory /run/lock/cryptsetup.  For sysVinit, this is taken
    care of by the cryptdisks-early init file.
  * Remove debian/patches/Use-system-libargon2.patch (applied upstream).
  * debian/README.{source,gbp.conf}: Upgrade to latest upstream conventions.
  * debian/control: Bump Standards-Version to 4.1.3 (remove verbatim copy of
    CC0-1.0 license from debian/copyright).
  * debian/rules: Fix symlink target of libcryptsetup.so in libcryptsetup-dev
    package.  Thanks to Alan Fung for the report and patch.  (Closes: #885435.)
  * debian/initramfs/cryptroot-{hook,script}: Add support for 'skip' and
    'offset' crypttab(5) options in the initramfs script.  Thanks to Pascal
    Liehne for the report and patch.  (Closes: #872342.)

  [ Jonas Meurer ]
  * debian/initramfs/cryptopensc-*: Install required libs and config files for
    pcscd and use correct path to pcscd. Thanks to Martijn van de Streek for
    bugreport and patch. (Closes: #880750)

 -- Guilhem Moulin <guilhem@debian.org>  Mon, 22 Jan 2018 00:25:52 +0100

cryptsetup (2:2.0.0~rc1-1) experimental; urgency=low

  * debian/rules: Compile with --enable-libargon2 to use system libargon2
    instead of bundled version.
  * debian/control: Bump Standards-Version to 4.1.1 (no changes necessary).
  * debian/copyright: Update licensing information.

 -- Guilhem Moulin <guilhem@debian.org>  Wed, 01 Nov 2017 17:37:15 +0100

cryptsetup (2:2.0.0~rc0-1) experimental; urgency=low

  * New upstream release 2.0.0 RC0 (closes: #877566).  Highlights include:
    - Support for new on-disk LUKS2 format, offering authenticated disk
      encrption (EXPERIMENTAL), memory-hard PBKDF (argon2), kernel keyring for
      storage of key material, and more.


=== debian/control ===
--- 
+++ 
@@ -1,20 +1,47 @@
 Source: cryptsetup
 Section: admin
 Priority: optional
-Maintainer: Debian Cryptsetup Team <pkg-cryptsetup-devel@lists.alioth.debian.org>
-Uploaders: Jonas Meurer <mejo@debian.org>,
- Guilhem Moulin <guilhem@guilhem.org>
-Build-Depends: libgcrypt20-dev (>= 1.6.1), libdevmapper-dev (>= 2:1.02.24-4), libpopt-dev, uuid-dev, libselinux1-dev, libsepol1-dev, libtool (>= 2.2), autoconf, automake (>= 1:1.12), pkg-config, autopoint, gettext, debhelper (>= 9.20120410~), xsltproc, docbook-xml, docbook-xsl (>= 1.74.3+dfsg), dpkg-dev (>= 1.15.1), po-debconf, dh-strip-nondeterminism
-Standards-Version: 3.9.8
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Cryptsetup Team <pkg-cryptsetup-devel@lists.alioth.debian.org>
+Uploaders: Jonas Meurer <mejo@debian.org>, Guilhem Moulin <guilhem@debian.org>
+Build-Depends: autoconf,
+               automake (>= 1:1.12),
+               autopoint,
+               debhelper (>= 9.20160403~),
+               dh-strip-nondeterminism,
+               docbook-xml,
+               docbook-xsl (>= 1.74.3+dfsg),
+               dpkg-dev (>= 1.15.1),
+               gettext,
+               libargon2-0-dev,
+               libdevmapper-dev (>= 2:1.02.24-4),
+               libgcrypt20-dev (>= 1.6.1),
+               libjson-c-dev,
+               libpopt-dev,
+               libselinux1-dev,
+               libsepol1-dev,
+               libtool (>= 2.2),
+               pkg-config,
+               po-debconf,
+               uuid-dev,
+               xsltproc
+Standards-Version: 4.1.3
 Homepage: https://gitlab.com/cryptsetup/cryptsetup
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-cryptsetup/cryptsetup.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-cryptsetup/cryptsetup.git
 
 Package: cryptsetup
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}, dmsetup, cryptsetup-bin (>= 2:1.6.0)
-Recommends: kbd, console-setup, initramfs-tools (>= 0.91) | linux-initramfs-tool, busybox | busybox-static
-Suggests: dosfstools, liblocale-gettext-perl, keyutils
+Depends: cryptsetup-bin (>= 2:1.6.0),
+         dmsetup,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: busybox-static | busybox,
+            console-setup,
+            initramfs-tools (>= 0.129) | linux-initramfs-tool,
+            kbd,
+            plymouth
+Suggests: dosfstools, keyutils, liblocale-gettext-perl
 Provides: cryptsetup-luks
 Conflicts: cryptsetup-luks
 Replaces: cryptsetup-luks, hashalot (<< 0.3-2)
@@ -33,7 +60,7 @@
 
 Package: cryptsetup-bin
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Breaks: cryptsetup (<< 2:1.4.3-1~)
 Replaces: cryptsetup (<< 2:1.4.3-1~)
 Description: disk encryption support - command line tools
@@ -44,11 +71,13 @@
  .
  This package provides cryptsetup, cryptsetup-reencrypt and luksformat.
 
-Package: libcryptsetup4
+Package: libcryptsetup12
 Section: libs
 Architecture: linux-any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libgpg-error0 (>= 1.10-0.1), libgcrypt20 (>= 1.6.1)
+Depends: libgpg-error0 (>= 1.10-0.1),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: disk encryption support - shared library
  Cryptsetup provides an interface for configuring encryption on block
  devices (such as /home or swap partitions), using the Linux kernel
@@ -61,7 +90,7 @@
 Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
-Depends: ${misc:Depends}, libcryptsetup4 (= ${binary:Version})
+Depends: libcryptsetup12 (= ${binary:Version}), ${misc:Depends}
 Description: disk encryption support - development files
  Cryptsetup provides an interface for configuring encryption on block
  devices (such as /home or swap partitions), using the Linux kernel
@@ -74,7 +103,7 @@
 Section: debian-installer
 Package-Type: udeb
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}, dmsetup-udeb
+Depends: dmsetup-udeb, ${misc:Depends}, ${shlibs:Depends}
 Description: disk encryption support - commandline tools (udeb)
  Cryptsetup provides an interface for configuring encryption on block
  devices (such as /home or swap partitions), using the Linux kernel
@@ -83,11 +112,11 @@
  .
  This udeb package provides cryptsetup for the Debian Installer.
 
-Package: libcryptsetup4-udeb
+Package: libcryptsetup12-udeb
 Section: debian-installer
 Package-Type: udeb
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: disk encryption support - shared library (udeb)
  Cryptsetup provides an interface for configuring encryption on block
  devices (such as /home or swap partitions), using the Linux kernel

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/architecture.mk
+
+# Export dpkg build flags
+DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie
+DEB_CFLAGS_MAINT_APPEND = -Wall
+DPKG_EXPORT_BUILDFLAGS  = 1
+include /usr/share/dpkg/default.mk
 
 # Turn on verbose mode.
 export V=1
@@ -8,14 +14,14 @@
 # Uncomment this to turn on debhelper verbose mode.
 #export DH_VERBOSE=1
 
-DEB_VERSION := $(strip $(shell LC_ALL=C dpkg-parsechangelog --show-field Version))
-DEB_DATE    := $(strip $(shell LC_ALL=C dpkg-parsechangelog --show-field Date | \
-                               LC_ALL=C date -u --file=- +%F                    ))
+-include /usr/share/dpkg/pkg-info.mk
 
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
 export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+
+DEB_DATE := $(strip $(shell LC_ALL=C date -u +%F -d@$(SOURCE_DATE_EPOCH)))
 
 ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
   confflags += --build $(DEB_HOST_GNU_TYPE)
@@ -25,12 +31,6 @@
 ifeq ($(origin CC),default)
   CC := $(DEB_HOST_GNU_TYPE)-gcc
 endif
-
-# Export dpkg build flags
-DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie
-DEB_CFLAGS_MAINT_APPEND = -Wall
-DPKG_EXPORT_BUILDFLAGS  = 1
--include /usr/share/dpkg/buildflags.mk
 
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 	INSTALL_PROGRAM += -s
@@ -44,12 +44,13 @@
 configure-stamp:
 	dh_testdir
 	find -xtype f ! -name manifest >manifest
-	autoreconf --force --install
+	dh_autoreconf
 	./configure $(confflags)  \
 		--prefix=/usr \
 		--libdir=/lib \
 		--sbindir=/sbin \
 		--mandir=/usr/share/man \
+		--enable-libargon2 \
 		--enable-shared \
 		--enable-cryptsetup-reencrypt
 	find -xtype f >manifest.new
@@ -79,8 +80,8 @@
 	# build upstream cryptsetup
 	$(MAKE)
 	# build askpass and passdev keyscripts
-	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -pedantic -std=c99 debian/askpass.c -o debian/askpass
-	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -pedantic -std=c99 debian/passdev.c -o debian/scripts/passdev
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -pedantic debian/askpass.c -o debian/askpass
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -pedantic debian/passdev.c -o debian/scripts/passdev
 
 build: build-indep build-arch
 
@@ -91,16 +92,16 @@
 	dh_clean
 	dh_installdirs
 	mkdir -p $(CURDIR)/debian/cryptsetup-udeb
-	mkdir -p $(CURDIR)/debian/libcryptsetup4-udeb
+	mkdir -p $(CURDIR)/debian/libcryptsetup12-udeb
 	$(MAKE) DESTDIR=$(CURDIR)/debian/cryptsetup-bin install
 
 	# Copy library files to library packages
-	mkdir -p $(CURDIR)/debian/libcryptsetup4/lib/$(DEB_HOST_MULTIARCH)/
+	mkdir -p $(CURDIR)/debian/libcryptsetup12/lib/$(DEB_HOST_MULTIARCH)/
 	mkdir -p $(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
-	#mkdir -p $(CURDIR)/debian/libcryptsetup4/usr/lib/$(DEB_HOST_MULTIARCH)/
+	#mkdir -p $(CURDIR)/debian/libcryptsetup12/usr/lib/$(DEB_HOST_MULTIARCH)/
 
 	cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.so.* \
-		$(CURDIR)/debian/libcryptsetup4/lib/$(DEB_HOST_MULTIARCH)/
+		$(CURDIR)/debian/libcryptsetup12/lib/$(DEB_HOST_MULTIARCH)/
 	#cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.la \
 	#	$(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
 	#cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.a \
@@ -111,7 +112,9 @@
 		$(CURDIR)/debian/libcryptsetup-dev/usr/include/
 	#cp -a $(CURDIR)/debian/cryptsetup-bin/lib/libcryptsetup.so \
 	#	$(CURDIR)/debian/libcryptsetup-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
-	dh_link -plibcryptsetup-dev lib/$(DEB_HOST_MULTIARCH)/$$(basename $$(readlink debian/libcryptsetup4/lib/$(DEB_HOST_MULTIARCH)/libcryptsetup.so.4)) usr/lib/$(DEB_HOST_MULTIARCH)/libcryptsetup.so
+	mkdir -p $(CURDIR)/debian/cryptsetup-bin/usr/lib/tmpfiles.d
+	install -m0644 ./scripts/cryptsetup.conf $(CURDIR)/debian/cryptsetup-bin/usr/lib/tmpfiles.d
+	dh_link -plibcryptsetup-dev lib/$(DEB_HOST_MULTIARCH)/$$(basename $$(readlink debian/libcryptsetup12/lib/$(DEB_HOST_MULTIARCH)/libcryptsetup.so.12)) usr/lib/$(DEB_HOST_MULTIARCH)/libcryptsetup.so
 
 	# Remove libraries from cryptsetup package, they're shiped in seperate library packages
 	rm -rf $(CURDIR)/debian/cryptsetup-bin/lib
@@ -176,5 +179,6 @@
 	dh_installchangelogs -a
 	dh_installdocs -a
 	dh_installexamples -a debian/scripts/gen-ssl-key
-	dh_installinit -a --no-start --name=cryptdisks-early --update-rcd-params="start 26 S . start 59 0 6 ."
+	dh_installinit -a --no-start --name=cryptdisks-early
 	dh_installinit -a --no-start --name=cryptdisks-udev
+	dh_installinit -a --no-start --name=cryptdisks
